// Birthday Add-in
// Displays all birthdays (from OUTLOOK Syntax)
// Sorts by Name or Date, Ascending or Descending
// (Original concept by Arjan Meskers)
// Updated by:  Nic Young


#include <rex/rex.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "birthday.h"

typedef struct BDAY_ITEM {
	char name[31];
	char year[5];
	char day[3];
	char month[3];
} BDAY_ITEM;   //Struct for saving each birthday (add age if you want to 
			   //								  display age in addin)
enum{
	
	SORT_BY_NAME_A,
	SORT_BY_NAME_D,
	SORT_BY_DATE_A,
	SORT_BY_DATE_D

};



const char version[15] = "Birthdays v1.2";  //Title to display on title bar at top



const int LINES_PER_PAGE = 9;  // How many lines per each page (9 fit reasonably well)







main() {
	// Declares //
	MSG msg;
	CDATE currentDate;
	CTIME currentTime;
	char title[210];
	int x = 1;
	char eventDay[3], eventMonth[3], eventYear[5];
	int eventDate[2];
	int i = 0;
	int idx = 0;
	int RecordCursor = 0;
	char name[31], /*age[4], birthYear[5], */currentYear[5];
	// Removed age and birthyear so that I can just use outlook's
	// birthday field of the contact list to enter birthdays

	BDAY_ITEM birthdays[100]; //Maximum of 100 Records, this can be
							  //increased within the reasonable memory
							  //limits.

	int dbHandle, repeat, recordId, len, flag, ageInt, readRecords = 1, line = 15;
	int beginlineNo = 15;
	// Program //
	DsClearScreen();	
	//DsEventAdd(1, 1, 240, 120, 61, 1);	/* Click screen to terminate addin */
    DsEventAdd(213,1,20,15,10,1); /* X to terminate Addin */
	DsEventAdd(2,1,22,15,11,1); /* Option Menu */
	DsEventAdd(35,40,150,15,12,0); //MENU OPTIONS
	DsEventAdd(35,57,150,15,13,0);
	DsEventAdd(35,74,150,15,14,0);
	DsEventAdd(35,91,150,15,15,0);		

	DsDisplayBitmapDraw(0,0,b_TitleBar,1);
	
	DsPrintf(80, 3, 0x11, version);
    //I removed column headers as I think they are obvious

	//DsDisplayLine(0, 11, 240, 0, LINE_SOLID);
	DbBeginTransaction();
	dbHandle = DsDbOpen(DBID_CALENDAR);		/* Open calendar database */
	recordId = DbFindRecord(dbHandle, 1, 1, 0L);	/* find the first record */

	while (readRecords == 1) {
		DbReadField(dbHandle,CAL_SCHED_RPT_TYPE, &repeat);		/* Get repeat type of calendar item */
		if (repeat == CAL_RPT_YEARLY) {
			DbReadText(dbHandle, CAL_SCHED_TITLE, 0, 200, &len, &title[0]);	/* Get calendar item title */
			title[len] = '\0';
			if (strcmp(&title[len - 8],"Birthday") == 0){
				substr(name, title, 0, len - 12);		/* Split title in name */
				/*substr(birthYear, title, len - 5, len - 2);*/	/* and year of birth */
				
				DbReadField(dbHandle,CAL_SCHED_DATE,&eventDate[0]);	/* Get event date */

				itoa(eventDay, eventDate[0] & 255 );			/* Day in low byte */
				if (eventDay[1] == '\0') {
					eventDay[1] = eventDay[0];
					eventDay[0] = '0';
					eventDay[2] = '\0';
				}
				
				itoa(eventMonth, eventDate[0] / 256 );			/* Month in high byte */
				if (eventMonth[1] == '\0') {
					eventMonth[1] = eventMonth[0];
					eventMonth[0] = '0';
				}
					eventMonth[2] = '\0';

				itoa(eventYear, eventDate[1]);				/* Year in high word */

				//Get current year
				DsCalCurrentTime(currentDate, currentTime);

				/* If current date is after birthday, set date to next year */
				if (((eventDate[0] / 256) == currentDate.month && (eventDate[0] & 255) < currentDate.day) || ((eventDate[0] / 256) < currentDate.month)) {
					currentDate.year += 1;
					itoa(currentYear, currentDate.year);
				} else {
					itoa(currentYear, currentDate.year);
				}					
				
				//ageInt = atoi(currentYear) - atoi(birthYear);		/* Calculate age */
				//itoa(age, ageInt);
					
				/*line += 10;
								
				DsPrintf(10, line, TEXT_NORMAL, name);
				DsPrintf(160, line, TEXT_NORMAL, eventMonth);
				DsPrintf(170, line, TEXT_NORMAL, "-");
				DsPrintf(175, line, TEXT_NORMAL, eventDay);
				DsPrintf(185, line, TEXT_NORMAL, "-");
				DsPrintf(190, line, TEXT_NORMAL, currentYear);*/
				//for(i = 0; i < 5; i++){

				// ADD THIS EVENT TO THE ARRAY FOR DISPLAY LATER

					strcpy(birthdays[idx].name, name);
					strcpy(birthdays[idx].month, eventMonth);
					strcpy(birthdays[idx].day, eventDay);
					strcpy(birthdays[idx++].year, currentYear);
				//}

			}
		}
		readRecords = DbNextRecord(dbHandle);
	}
	SortData(birthdays,idx,SORT_BY_DATE_A);                //SORT THE DATA
	PrintData(idx,RecordCursor,birthdays);  //PRINT STARTING AT FIRST PAGE
    DsDialogScrollBarDraw(225, 19, 101, (idx - (LINES_PER_PAGE-1))); //DRAW SCROLL BAR
	DsDialogScrollThumbSet(0); /*Start at item 0 of idx */
	DbEndTransaction(1,0);
	DbClose(dbHandle);
	
	flag=1;
	while(flag) {
		DsEventMessageGet(msg);
		switch (msg.message) {
			case MSG_DS_CLOSE:
				flag=0;
				break;
			case MSG_DS_KEY_DOWN:
				switch ( msg.sCode ) 
				{
					case KEY_TOP_C:
						DsClearScreen();
						DsAddinTerminate();
						break;
					case KEY_BACK_A	:
						break;
					case KEY_ENTER_A:
						break;
					case KEY_UP_A:
						if (RecordCursor > 0) {
							RecordCursor -= LINES_PER_PAGE;
							if (RecordCursor < 0)
								RecordCursor = 0;
							PrintData(idx,RecordCursor,birthdays);
							DsDialogScrollThumbSet(RecordCursor); 
						}
						break;
					case KEY_DOWN_A:
						if (RecordCursor < (idx - LINES_PER_PAGE)) {
							RecordCursor += LINES_PER_PAGE;
							if ((RecordCursor + (LINES_PER_PAGE - 1)) > (idx - 1))
								RecordCursor = idx - LINES_PER_PAGE;
							PrintData(idx,RecordCursor,birthdays);
							DsDialogScrollThumbSet(RecordCursor); 
						}
						break;
				}
				break;
			case MSG_DS_PAINT:
				break;
			case MSG_DS_COMMAND:
				switch (msg.bCode) {
					case 10:  //X to quit
						DsBeepOn(2);
						DsEventClear();
						DsClearScreen();
						DsAddinTerminate();
						break;
					case 11:  //Option Menu
						DsBeepOn(2);
						DsDisplayBlockClear(0,18,210,108);
						DsDisplayBitmapDraw(0,0,b_LeftBar,1);
						DsEventEnable(12);
						DsEventEnable(13);
						DsEventEnable(14);
						DsEventEnable(15);
						DsDisplayBlock(0,18,30,10,1);
						DsDisplayBlock(0,28,200,80,1);
						DsDisplayBlockReverse(37,40,10,10,1);
						DsDisplayBlockReverse(37,57,10,10,1);
						DsDisplayBlockReverse(37,74,10,10,1);
						DsDisplayBlockReverse(37,91,10,10,1);
						DsPrintf(55, 40, 0x11, "Name (Ascending)");
						DsPrintf(55, 57, 0x11, "Name (Descending)");
						DsPrintf(55, 74, 0x11, "Date (Ascending)");
						DsPrintf(55, 91, 0x11, "Date (Descending)");
						break;
					case 12:
						DsBeepOn(2);
						Reset();
						SortData(birthdays,idx,SORT_BY_NAME_A);
						RecordCursor=0;
						PrintData(idx,RecordCursor,birthdays);
						break;
					case 13:
						DsBeepOn(2);
						Reset();
						SortData(birthdays,idx,SORT_BY_NAME_D);
						RecordCursor=0;
						PrintData(idx,RecordCursor,birthdays);
						break;
					case 14:
						DsBeepOn(2);
						Reset();
						SortData(birthdays,idx,SORT_BY_DATE_A);
						RecordCursor=0;
						PrintData(idx,RecordCursor,birthdays);
						break;
					case 15:
						DsBeepOn(2);
						Reset();
						SortData(birthdays,idx,SORT_BY_DATE_D);
						RecordCursor=0;
						PrintData(idx,RecordCursor,birthdays);
						break;
					case MSG_DS_SCROLLUP:
					case MSG_DS_SCROLLUP_REPEAT:
						if (RecordCursor > 0) {
							RecordCursor--;
							PrintData(idx,RecordCursor,birthdays);
							DsDialogScrollThumbSet(RecordCursor); 
						}
						break;
					case MSG_DS_SCROLLDOWN:
					case MSG_DS_SCROLLDOWN_REPEAT:
						if (RecordCursor < (idx - LINES_PER_PAGE)) {
							RecordCursor++;
							PrintData(idx,RecordCursor,birthdays);
							DsDialogScrollThumbSet(RecordCursor); 
						}
						break;
/*					case MSG_DS_PAGEUP:
					case MSG_DS_PAGEUP_REPEAT:
						if (RecordCursor > 0) {
							RecordCursor -= LINES_PER_PAGE;
							if (RecordCursor < 0)
								RecordCursor = 0;
							PrintData(idx,RecordCursor,birthdays);
							DsDialogScrollThumbSet(RecordCursor); 
						}
						break;
					case MSG_DS_PAGEDOWN:
					case MSG_DS_PAGEDOWN_REPEAT:
						if (RecordCursor < (idx - LINES_PER_PAGE)) {
							RecordCursor += LINES_PER_PAGE;
							if ((RecordCursor + LINES_PER_PAGE - 1) > (idx - 1))
								RecordCursor = idx - LINES_PER_PAGE;
							PrintData(idx,RecordCursor,birthdays);
							DsDialogScrollThumbSet(RecordCursor); 
						}
						break;
*/
				}
		}
	}
}

substr(output, input, beginPos, endPos) char *output, *input; int beginPos, endPos; {
    int i;

    char *temp;
    temp = input;
    temp += beginPos;
    for(i = beginPos; i <= endPos && i < 60; i++) {
        *output = *temp;
        *output++; *temp++;
    }
    *output='\0';
}

PrintData(idx, firstRecord, birthdays) int idx, firstRecord; BDAY_ITEM birthdays[100]; {
	int line = 12;
	int i = 0;
	int stop = 0;
	if (firstRecord < 0)
		firstRecord = 0;
	if ((firstRecord + LINES_PER_PAGE) > idx){
		stop = idx;
	}else{
		stop = firstRecord + LINES_PER_PAGE;
	}
	DsDisplayBlockClear(0,20,210,108);  //CLEAR BLOCK OF TEXT TO WRITE NEW
										//PAGE
	if (idx > 0) {
		for (i = firstRecord; i < stop; i++){
			line += 10;
			DsPrintf(10, line, TEXT_NORMAL, birthdays[i].name);
			DsPrintf(160, line, TEXT_NORMAL, birthdays[i].month);
			DsPrintf(170, line, TEXT_NORMAL, "-");
			DsPrintf(175, line, TEXT_NORMAL, birthdays[i].day);
			DsPrintf(185, line, TEXT_NORMAL, "-");
			DsPrintf(190, line, TEXT_NORMAL, birthdays[i].year);
		}
	}
}

SortData(birthdays, idx, typeofsort) BDAY_ITEM birthdays[100]; int idx; int typeofsort;{

	int i = 0;
	int j = 0;
	char tempInt[10];
	int compared=0;
	int startLine=10;

//	int check_Day=0;
//	int check_Month=0;
//	int check_Year=0;
	
	char strDateCheck[12];
	char strDateCompare[12];

	DsDisplayWaitIconDraw(1);

	switch ( typeofsort ){
		case SORT_BY_NAME_A:
			for (i = 0; i < idx; i++){ 
				for (j = 0;j < (idx - i - 1); j++){
					if (strcmp(birthdays[j].name,birthdays[j+1].name) > 0){
			
						SwapData(birthdays,j,j+1);

					}
				}
			}
		break;
		case SORT_BY_NAME_D:
			for (i = 0; i < idx; i++){ 
				for (j = 0;j < (idx - i - 1); j++){
					if (strcmp(birthdays[j].name,birthdays[j+1].name) < 0){
			
						SwapData(birthdays,j,j+1);

					}
				}
			}
		break;
		case SORT_BY_DATE_A:
		
			for (i = 0; i < idx; i++){ 

				for (j = 0;j < (idx - i - 1); j++){

					strcpy(strDateCheck, birthdays[j].year);
					strcat(strDateCheck, birthdays[j].month);
					strcat(strDateCheck, birthdays[j].day);
					
					strcpy(strDateCompare, birthdays[j+1].year);
					strcat(strDateCompare, birthdays[j+1].month);
					strcat(strDateCompare, birthdays[j+1].day);

					if (strcmp(strDateCheck,strDateCompare) > 0){
					
						SwapData(birthdays,j,j+1);
					
					}
				}
			}
		break;
		case SORT_BY_DATE_D:
			for (i = 0; i < idx; i++){ 

				for (j = 0;j < (idx - i - 1); j++){

					strcpy(strDateCheck, birthdays[j].year);
					strcat(strDateCheck, birthdays[j].month);
					strcat(strDateCheck, birthdays[j].day);
					
					strcpy(strDateCompare, birthdays[j+1].year);
					strcat(strDateCompare, birthdays[j+1].month);
					strcat(strDateCompare, birthdays[j+1].day);

					if (strcmp(strDateCheck,strDateCompare) < 0){
					
						SwapData(birthdays,j,j+1);
					
					}
				}
			}
		break;
	}
	DsDisplayWaitIconDraw(0);
}

SwapData(birthdays, i, j) BDAY_ITEM birthdays[100]; int i; int j; {

	char hold_Name[31];
	char hold_Month[3];
	char hold_Day[3];
	char hold_Year[5];
	
	strcpy(hold_Name,          birthdays[i].name);
	strcpy(hold_Month,         birthdays[i].month);
	strcpy(hold_Day,           birthdays[i].day);
	strcpy(hold_Year,          birthdays[i].year);

	strcpy(birthdays[i].name,  birthdays[j].name);
	strcpy(birthdays[i].month, birthdays[j].month);
	strcpy(birthdays[i].day,   birthdays[j].day);
	strcpy(birthdays[i].year,  birthdays[j].year);

	strcpy(birthdays[j].name,  hold_Name);
	strcpy(birthdays[j].month, hold_Month);
	strcpy(birthdays[j].day,   hold_Day);
	strcpy(birthdays[j].year,  hold_Year);		
}

DisableOptions(){

	DsEventDisable(12);
	DsEventDisable(13);
	DsEventDisable(14);
	DsEventDisable(15);


}

Reset() {

	DisableOptions();
	DsDisplayBlockClear(0,18,210,108);
	DsDisplayBitmapDraw(0,0,b_TitleBar,1);
	DsPrintf(80, 3, 0x11, version);

}


}